diff -Nur postgresql-7.4-orig/src/backend/catalog/genbki.sh postgresql-7.4/src/backend/catalog/genbki.sh
--- postgresql-7.4-orig/src/backend/catalog/genbki.sh	2003-07-29 07:12:50.000000000 -0700
+++ postgresql-7.4/src/backend/catalog/genbki.sh	2003-11-19 12:53:03.000000000 -0800
@@ -113,7 +113,7 @@
 fi
 
 
-TMPFILE="$TMPDIR/genbkitmp$$.c"
+TMPFILE="$TMPDIR/genbkitmp$$.h"
 
 trap "rm -f $TMPFILE ${OUTPUT_PREFIX}.bki.$$ ${OUTPUT_PREFIX}.description.$$" 0 1 2 3 15
 
diff -Nur postgresql-7.4-orig/src/include/storage/s_lock.h postgresql-7.4/src/include/storage/s_lock.h
--- postgresql-7.4-orig/src/include/storage/s_lock.h	2003-11-04 01:43:56.000000000 -0800
+++ postgresql-7.4/src/include/storage/s_lock.h	2003-11-19 12:50:33.000000000 -0800
@@ -462,6 +462,39 @@
 
 #endif	 /* __hppa */
 
+#if defined(__hpux) && defined(__ia64)
+/*
+ * HP-UX IA-64.
+ * Inlined tas routine for HP-C compiler.
+ * Inlined tas for IA-64 gcc compiler is already
+ * given at top.
+ */
+#if defined(__HP_aCC) || defined(__HP_cc)
+
+#include <machine/sys/inline.h>
+#define TAS(lock) tas(lock)
+#define tas(lock) \
+ ( \
+   _Asm_xchg((_Asm_sz)_SZ_W, \
+    (volatile slock_t*)lock, \
+    (int)1, (_Asm_ldhint)_LDHINT_NONE) \
+ )
+
+#define S_UNLOCK(lock) \
+  ( \
+    _Asm_mov_to_ar((_Asm_app_reg)_AREG_CCV, 1UL),\
+      (_Asm_cmpxchg((_Asm_sz)_SZ_W, _SEM_REL, \
+                    (volatile slock_t*)lock, \
+                    0UL, (_Asm_ldhint)_LDHINT_NONE, \
+                    (_UP_MEM_FENCE|_DOWN_MEM_FENCE)) == 1) ? 1 : 0 \
+    )
+
+#define S_LOCK_FREE(lock)       ( *(volatile slock_t*)(lock))
+
+#endif  /*  __HP_aCC || __HP_cc */
+#endif  /*  __hpux && __ia64 */
+
+
 #if defined(__QNX__) && defined(__WATCOMC__)
 /*
  * QNX 4 using WATCOM C
